package com.PFE.ServerManager;

import javax.persistence.*;
import java.util.Set;

@Entity
@Table(name = "node")
public class Node {
    @Id
    @Column(name = "node_id", columnDefinition = "serial")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Integer node_id;

    @Column(name = "name")
    private String name;

    @Column(name = "ip")
    private String ip;

    @Column(name = "arch")
    private String arch;

    @ManyToMany(cascade = CascadeType.ALL)
    @JoinTable(name = "nodes_sensor", joinColumns = @JoinColumn(name = "node_id"), inverseJoinColumns = @JoinColumn(name = "sensorId"))
    private Set<Sensor> sensors;

    public void setSensors(Set<Sensor> sensors) {
        this.sensors = sensors;
    }

    public void setNode_id(Integer node_id) {
        this.node_id = node_id;
    }

    public void setName(String name) {
        this.name = name;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public void setArch(String arch) {
        this.arch = arch;
    }

    public Integer getNode_id() {
        return node_id;
    }

    public String getName() {
        return name;
    }

    public String getIp() {
        return ip;
    }

    public String getArch() {
        return arch;
    }

    public Set<Sensor> getSensors() {
        return sensors;
    }

}
