package com.PFE.ServerManager;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Entity
@Table(name = "team")
public class Team {

    @Id
    @Column(columnDefinition = "serial")
    //@GeneratedValue(strategy = GenerationType.AUTO)
    @Basic(optional = false)
    private Integer teamId;

    @Column(name = "teamName")
    private String team;

    @ManyToMany(cascade = CascadeType.ALL)
    @JoinTable(name = "team_update", joinColumns = @JoinColumn(name = "teamId"), inverseJoinColumns = @JoinColumn(name = "updateId"))
    private Set<Update> updates;

    @ManyToMany(cascade = CascadeType.ALL)
    @JoinTable(name = "team_customer", joinColumns = @JoinColumn(name = "teamId"), inverseJoinColumns = @JoinColumn(name = "customerId"))
    private Set<Customer> customers;


    public void setTeam(String team) {
        this.team = team;
    }
    public String getTeam() {
        return team;
    }

    public void setTeamId(Integer teamId) {
        this.teamId = teamId;
    }
    public Integer getTeamId() {
        return teamId;
    }

    public void setCustomers(Set<Customer> customers) {
        this.customers = customers;
    }
    public Set<Customer> getCustomers() {
        return customers;
    }
    public void addCustomer(Customer customer){
        if(customers == null){
            customers = new HashSet<>();
        }
        this.customers.add(customer);
    }

    public void setUpdates(Set<Update> updates) {
        this.updates = updates;
    }
    public Set<Update> getUpdates() {
        return updates;
    }
    public void addUpdate(Update update){
        if(updates == null) {
            updates = new HashSet<>();
        }
        this.updates.add(update);
    }
}
